<?php
/**
 * indexHue.php - Script to allow the Admin to index the albums for most domiment hue in the pictures
 *
 * See README for installation and usage.
 *
 *
 * @copyright Aditya Mooley <adityamooley@sanisoft.com>, Tarique Sani <tarique@sanisoft.com>
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 *
 */

define('IN_COPPERMINE', true);
require('include/init.inc.php');
if (!GALLERY_ADMIN_MODE) cpg_die(ERROR, 'Access denied', __FILE__, __LINE__);

function createForm($error = false)
{
global $CONFIG;
$query = "SELECT aid, title FROM {$CONFIG['TABLE_ALBUMS']} WHERE category < " . FIRST_USER_CAT . " ORDER BY title";
$public_albums = cpg_db_query($query);
if (mysql_num_rows($public_albums)) {
    $public_albums_list = cpg_db_fetch_rowset($public_albums);
} else {
    $public_albums_list = array();
}
$query = "SELECT aid, title FROM {$CONFIG['TABLE_ALBUMS']} WHERE category='" . (FIRST_USER_CAT + USER_ID) . "' ORDER BY title";
$user_albums = cpg_db_query($query);
if (mysql_num_rows($user_albums)) {
    $user_albums_list = cpg_db_fetch_rowset($user_albums);
} else {
    $user_albums_list = array();
}
if (count($public_albums_list) && count($user_albums_list)) {
  cpg_die(ERROR, "Albums not found", __FILE__, __LINE__);
}
pageheader("Index images for search by color");
starttable('50%', "Index photos in the album", 2);
if ($error) {
echo <<<EOT
  <tr>
      <td colspan="2" align="center" class="tablef">
         <span style="color: red;">Album is empty or does not exist. Please try again.</span>
      </td>
  </tr>
EOT;
}
/**
 * Create the album array
 */
echo <<<EOT
  <form method="post">
EOT;

// Check to see if an album has been preselected by URL addition. If so, make $sel_album the album number. Otherwise, make $sel_album 0.
$sel_album = isset($_POST['albid']) ? $_POST['albid'] : 0;

// Create the opening of the drop down box
echo <<<EOT
<tr>
    <td class="tableb">
        Select album to be indexed
    </td>
    <td class="tableb" valign="top">
        <select name="albid" class="listbox">

EOT;

// Reset counter
$list_count = 0;
// Cycle through the User albums
foreach($user_albums_list as $album) {

    // Add to multi-dim array for later sorting
    $listArray[$list_count]['cat'] = $lang_upload_php['personal_albums'];
    $listArray[$list_count]['aid'] = $album['aid'];
    $listArray[$list_count]['title'] = $album['title'];
    $list_count++;
}

// Cycle through the public albums
foreach($public_albums_list as $album) {

    // Set $album_id to the actual album ID
    $album_id = $album['aid'];

    // Get the category name
    $vQuery = "SELECT cat.name FROM " . $CONFIG['TABLE_CATEGORIES'] . " cat, " . $CONFIG['TABLE_ALBUMS'] . " alb WHERE alb.aid='" . $album_id . "' AND cat.cid=alb.category";
    $vRes = cpg_db_query($vQuery);
    $vRes = mysql_fetch_array($vRes);

    // Add to multi-dim array for sorting later
    if ($vRes['name']) {
        $listArray[$list_count]['cat'] = $vRes['name'];
    } else {
        $listArray[$list_count]['cat'] = $lang_upload_php['albums_no_category'];
    }
    $listArray[$list_count]['aid'] = $album['aid'];
    $listArray[$list_count]['title'] = $album['title'];
    $list_count++;
}

// Sort the pulldown options by category and album name
$listArray = array_csort($listArray,'cat','title');

// Finally, print out the nicely sorted and formatted drop down list
$alb_cat = '';
    echo '                <option value="">Select Album</option>\n';
foreach ($listArray as $val) {
    if ($val['cat'] != $alb_cat) {
    if ($alb_cat) echo "                </optgroup>\n";
            echo '                <optgroup label="' . $val['cat'] . '">' . "\n";
            $alb_cat = $val['cat'];
        }
        echo '                <option value="' . $val['aid'] . '^'.$val["title"].'"' . ($val['aid'] == $sel_album ? ' selected' : '') . '>   ' . $val['title'] . "</option>\n";
    }
    if ($alb_cat) echo "                </optgroup>\n";

    // Close the drop down
    echo <<<EOT
            </select>
        </td>
    </tr>
    <tr>
      <td colspan="2" align="center" class="tablef">
        <input type="checkbox" name="skip" value="skip" CHECKED> Skip already indexed images.
      </td>
    </tr>
    <tr>
      <td colspan="2" align="center" class="tablef">
        <input type="submit" value="Index Album Pictures" class="button">
      </td>
    </tr>
  </form>
EOT;
endtable();
}

if (isset($_POST["albid"]) && !empty($_POST["albid"])) {
  list($aid, $albName) = explode("^", $_POST["albid"]);
  $skip = isset($_POST["skip"]) ? "skip" : "or";
  $query = "SELECT pid, aid, filepath, filename FROM {$CONFIG['TABLE_PICTURES']} WHERE aid = '$aid'";
  $result = mysql_query($query);
  if (mysql_num_rows($result) > 0) {
    pageheader("Indexing images ...");
    starttable('50%', "Indexing photos in album $albName", 3);
    echo <<<EOT
    <tr>
      <td class="tableh2">Picture</td>
      <td class="tableh2">Name</td>
      <td class="tableh2">Result</td>
    </tr>
EOT;
    while ($row = mysql_fetch_array($result)) {
      echo <<<EOT
      <tr>
        <td class="tableb" valign="center" align="center"><img src="{$CONFIG["fullpath"]}{$row["filepath"]}thumb_{$row["filename"]}" /></td>
        <td class="tableb" valign="center" align="center">{$row["filename"]}</td>
        <td  class="tableb" valign="center"><img src="hue.php?pid={$row["pid"]}&skip={$skip}" /></td>
      </tr>
EOT;
      flush();
    }
    echo <<<EOT
      <tr>
        <td colspan="3" align="center" class="tableh2"><a href="indexHue.php">Index another album</a></td>
      </tr>
EOT;
    endtable();
    pagefooter();
  } else {
    createForm(true);
  }
} else {
  createForm();
}
?>