<?php
/**
 * searchbycolor.php - Script to search the pictures in coppermine by dominent color.
 *
 * See README for installation and usage.
 *
 *
 * @copyright Aditya Mooley <adityamooley@sanisoft.com>, Tarique Sani <tarique@sanisoft.com>
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License
 *
 */
$forb = str_replace("aid", $CONFIG['TABLE_PICTURES'].".aid", $forbidden_set_string);
$query = "SELECT count({$CONFIG['TABLE_PREFIX']}colors.pid) AS totalCount
            FROM
              {$CONFIG['TABLE_PICTURES']}, {$CONFIG['TABLE_PREFIX']}colors
            WHERE
              hue >= ". ($hue-5) ." AND hue <= ". ($hue+5) ." AND
              {$CONFIG['TABLE_PREFIX']}colors.pid = {$CONFIG['TABLE_PICTURES']}.pid
               $forb
              ";
$result = cpg_db_query($query);
if (@mysql_num_rows($result) > 0) {
  $row = mysql_fetch_array($result);
  $count = $row["totalCount"];
  mysql_free_result($result);
  $query = "SELECT *
              FROM
                {$CONFIG['TABLE_PICTURES']}, {$CONFIG['TABLE_PREFIX']}colors
              WHERE
                hue >= ". ($hue-5) ." AND hue <= ". ($hue+5) ." AND
                {$CONFIG['TABLE_PREFIX']}colors.pid = {$CONFIG['TABLE_PICTURES']}.pid
                $forb
                 ORDER BY percent DESC $limit";
    $result = cpg_db_query($query);

    if (@mysql_num_rows($result) > 0) {
      $rowset = cpg_db_fetch_rowset($result);
      if ($set_caption) foreach ($rowset as $key => $row) {
            $caption = $rowset[$key]['title'] ? "<span class=\"thumb_title\">" . $rowset[$key]['title'] . "</span>" : '';

            if ($CONFIG['caption_in_thumbview']) {
                $caption .= $rowset[$key]['caption'] ? "<span class=\"thumb_caption\">" . bb_decode($rowset[$key]['caption']) . "</span>" : '';
            }

            $rowset[$key]['caption_text'] = $caption;
        }
    }
} else {
  $count = 0;
}
?>